import{S as Hr,i as Er,s as Pr,e as a,k as d,w as _,t as s,M as Tr,c as n,d as t,m as c,a as r,x as b,h as i,b as l,G as e,g as m,y as v,q as y,o as w,B as x,v as jr,L as kr}from"../../chunks/vendor-hf-doc-builder.js";import{T as xr}from"../../chunks/Tip-hf-doc-builder.js";import{D as A}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Mr}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as co}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as $r}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Dr(V){let g,k,u,f,M;return f=new Mr({props:{code:`import torch
import torch.nn as nn
from huggingface_hub import PyTorchModelHubMixin


class MyModel(nn.Module, PyTorchModelHubMixin):
    def __init__(self):
        super().__init__()
        self.param = nn.Parameter(torch.rand(3, 4))
        self.linear = nn.Linear(4, 5)

    def forward(self, x):
        return self.linear(x + self.param)


model = MyModel()
# Save model weights to local directory
model.save_pretrained("my-awesome-model")
# Push model weights to the Hub
model.push_to_hub("my-awesome-model")
# Download and initialize weights from the Hub
model = MyModel.from_pretrained("username/my-awesome-model")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch.nn <span class="hljs-keyword">as</span> nn
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> PyTorchModelHubMixin


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">class</span> <span class="hljs-title class_">MyModel</span>(nn.Module, PyTorchModelHubMixin):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self</span>):
<span class="hljs-meta">... </span>        <span class="hljs-built_in">super</span>().__init__()
<span class="hljs-meta">... </span>        self.param = nn.Parameter(torch.rand(<span class="hljs-number">3</span>, <span class="hljs-number">4</span>))
<span class="hljs-meta">... </span>        self.linear = nn.Linear(<span class="hljs-number">4</span>, <span class="hljs-number">5</span>)

<span class="hljs-meta">... </span>    <span class="hljs-keyword">def</span> <span class="hljs-title function_">forward</span>(<span class="hljs-params">self, x</span>):
<span class="hljs-meta">... </span>        <span class="hljs-keyword">return</span> self.linear(x + self.param)


<span class="hljs-meta">&gt;&gt;&gt; </span>model = MyModel()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Save model weights to local directory</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.save_pretrained(<span class="hljs-string">&quot;my-awesome-model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Push model weights to the Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.push_to_hub(<span class="hljs-string">&quot;my-awesome-model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download and initialize weights from the Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = MyModel.from_pretrained(<span class="hljs-string">&quot;username/my-awesome-model&quot;</span>)`}}),{c(){g=a("p"),k=s("Example:"),u=d(),_(f.$$.fragment)},l(p){g=n(p,"P",{});var $=r(g);k=i($,"Example:"),$.forEach(t),u=c(p),b(f.$$.fragment,p)},m(p,$){m(p,g,$),e(g,k),m(p,u,$),v(f,p,$),M=!0},p:kr,i(p){M||(y(f.$$.fragment,p),M=!0)},o(p){w(f.$$.fragment,p),M=!1},d(p){p&&t(g),p&&t(u),x(f,p)}}}function Nr(V){let g,k;return g=new Mr({props:{code:`import tensorflow as tf
from huggingface_hub import KerasModelHubMixin


class MyModel(tf.keras.Model, KerasModelHubMixin):
    def __init__(self, **kwargs):
        super().__init__()
        self.config = kwargs.pop("config", None)
        self.dummy_inputs = ...
        self.layer = ...

    def call(self, *args):
        return ...


# Initialize and compile the model as you normally would
model = MyModel()
model.compile(...)
# Build the graph by training it or passing dummy inputs
_ = model(model.dummy_inputs)
# Save model weights to local directory
model.save_pretrained("my-awesome-model")
# Push model weights to the Hub
model.push_to_hub("my-awesome-model")
# Download and initialize weights from the Hub
model = MyModel.from_pretrained("username/super-cool-model")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> KerasModelHubMixin


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">class</span> <span class="hljs-title class_">MyModel</span>(tf.keras.Model, KerasModelHubMixin):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self, **kwargs</span>):
<span class="hljs-meta">... </span>        <span class="hljs-built_in">super</span>().__init__()
<span class="hljs-meta">... </span>        self.config = kwargs.pop(<span class="hljs-string">&quot;config&quot;</span>, <span class="hljs-literal">None</span>)
<span class="hljs-meta">... </span>        self.dummy_inputs = ...
<span class="hljs-meta">... </span>        self.layer = ...

<span class="hljs-meta">... </span>    <span class="hljs-keyword">def</span> <span class="hljs-title function_">call</span>(<span class="hljs-params">self, *args</span>):
<span class="hljs-meta">... </span>        <span class="hljs-keyword">return</span> ...


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initialize and compile the model as you normally would</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = MyModel()
<span class="hljs-meta">&gt;&gt;&gt; </span>model.<span class="hljs-built_in">compile</span>(...)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Build the graph by training it or passing dummy inputs</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>_ = model(model.dummy_inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Save model weights to local directory</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.save_pretrained(<span class="hljs-string">&quot;my-awesome-model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Push model weights to the Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.push_to_hub(<span class="hljs-string">&quot;my-awesome-model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download and initialize weights from the Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = MyModel.from_pretrained(<span class="hljs-string">&quot;username/super-cool-model&quot;</span>)`}}),{c(){_(g.$$.fragment)},l(u){b(g.$$.fragment,u)},m(u,f){v(g,u,f),k=!0},p:kr,i(u){k||(y(g.$$.fragment,u),k=!0)},o(u){w(g.$$.fragment,u),k=!1},d(u){x(g,u)}}}function Ar(V){let g,k,u,f,M;return{c(){g=a("p"),k=s("Passing "),u=a("code"),f=s("token=True"),M=s(` is required when you want to use a private
model.`)},l(p){g=n(p,"P",{});var $=r(g);k=i($,"Passing "),u=n($,"CODE",{});var I=r(u);f=i(I,"token=True"),I.forEach(t),M=i($,` is required when you want to use a private
model.`),$.forEach(t)},m(p,$){m(p,g,$),e(g,k),e(g,u),e(u,f),e(g,M)},d(p){p&&t(g)}}}function Ir(V){let g,k,u,f,M,p,$,I,we;return{c(){g=a("p"),k=s("Raises the following error:"),u=d(),f=a("ul"),M=a("li"),p=a("a"),$=a("em"),I=s("ValueError"),we=s(`
if the user is not log on to the Hugging Face Hub.`),this.h()},l(E){g=n(E,"P",{});var P=r(g);k=i(P,"Raises the following error:"),P.forEach(t),u=c(E),f=n(E,"UL",{});var z=r(f);M=n(z,"LI",{});var Q=r(M);p=n(Q,"A",{href:!0,rel:!0});var R=r(p);$=n(R,"EM",{});var Ve=r($);I=i(Ve,"ValueError"),Ve.forEach(t),R.forEach(t),we=i(Q,`
if the user is not log on to the Hugging Face Hub.`),Q.forEach(t),z.forEach(t),this.h()},h(){l(p,"href","https://docs.python.org/3/library/exceptions.html#ValueError"),l(p,"rel","nofollow")},m(E,P){m(E,g,P),e(g,k),m(E,u,P),m(E,f,P),e(f,M),e(M,p),e(p,$),e($,I),e(M,we)},d(E){E&&t(g),E&&t(u),E&&t(f)}}}function Lr(V){let g,k,u,f,M,p,$,I,we,E,P,z,Q,R,Ve,ho,xt,Bo,B,$t,go,kt,Mt,Re,Ht,Et,Go,X,ne,po,xe,Pt,mo,Tt,Yo,H,$e,jt,uo,Dt,Nt,j,At,fo,It,Lt,_o,zt,Ot,Be,St,Ft,Ge,Ct,Ut,qt,re,ke,Kt,Me,Wt,Ye,Vt,Rt,Bt,L,He,Gt,bo,Yt,Jt,D,Qt,Je,Xt,Zt,Qe,ea,oa,vo,ta,aa,yo,na,ra,sa,Ee,ia,Xe,la,da,ca,se,Pe,ha,wo,ga,pa,G,Te,ma,xo,ua,fa,O,_a,$o,ba,va,ko,ya,wa,Ze,xa,$a,ka,ie,je,Ma,Mo,Ha,Jo,Z,le,Ho,De,Ea,Eo,Pa,Qo,S,Ne,Ta,F,ja,eo,Da,Na,Po,Aa,Ia,To,La,za,Oa,de,Xo,ee,ce,jo,Ae,Sa,Do,Fa,Zo,C,Ie,Ca,Le,Ua,oo,qa,Ka,Wa,he,et,U,ze,Va,Oe,Ra,No,Ba,Ga,Ya,ge,ot,q,Se,Ja,Fe,Qa,Ao,Xa,Za,en,K,on,Io,tn,an,Lo,nn,rn,to,sn,ln,tt,oe,Ce,dn,zo,cn,at,te,pe,Oo,Ue,hn,So,gn,nt,ae,qe,pn,Fo,mn,rt,N,Ke,un,Co,fn,_n,W,bn,Uo,vn,yn,qo,wn,xn,Ko,$n,kn,Mn,me,st;return p=new co({}),R=new co({}),xe=new co({}),$e=new A({props:{name:"class huggingface_hub.ModelHubMixin",anchor:"huggingface_hub.ModelHubMixin",parameters:[],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L25"}}),ke=new A({props:{name:"_save_pretrained",anchor:"huggingface_hub.ModelHubMixin._save_pretrained",parameters:[{name:"save_directory",val:": Path"}],parametersDescription:[{anchor:"huggingface_hub.ModelHubMixin._save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>Path</code>) &#x2014;
Path to directory in which the model weights and configuration will be saved.`,name:"save_directory"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L79"}}),He=new A({props:{name:"_from_pretrained",anchor:"huggingface_hub.ModelHubMixin._from_pretrained",parameters:[{name:"model_id",val:": str"},{name:"revision",val:": typing.Optional[str]"},{name:"cache_dir",val:": typing.Union[str, pathlib.Path, NoneType]"},{name:"force_download",val:": bool"},{name:"proxies",val:": typing.Optional[typing.Dict]"},{name:"resume_download",val:": bool"},{name:"local_files_only",val:": bool"},{name:"token",val:": typing.Union[str, bool, NoneType]"},{name:"**model_kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.ModelHubMixin._from_pretrained.model_id",description:`<strong>model_id</strong> (<code>str</code>) &#x2014;
ID of the model to load from the Huggingface Hub (e.g. <code>bigscience/bloom</code>).`,name:"model_id"},{anchor:"huggingface_hub.ModelHubMixin._from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Revision of the model on the Hub. Can be a branch name, a git tag or any commit id. Defaults to the
latest commit on <code>main</code> branch.`,name:"revision"},{anchor:"huggingface_hub.ModelHubMixin._from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to force (re-)downloading the model weights and configuration files from the Hub, overriding
the existing cache.`,name:"force_download"},{anchor:"huggingface_hub.ModelHubMixin._from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to delete incompletely received files. Will attempt to resume the download if such a file exists.`,name:"resume_download"},{anchor:"huggingface_hub.ModelHubMixin._from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint (e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>).`,name:"proxies"},{anchor:"huggingface_hub.ModelHubMixin._from_pretrained.token",description:`<strong>token</strong> (<code>str</code> or <code>bool</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. By default, it will use the token
cached when running <code>huggingface-cli login</code>.`,name:"token"},{anchor:"huggingface_hub.ModelHubMixin._from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>str</code>, <code>Path</code>, <em>optional</em>) &#x2014;
Path to the folder where cached files are stored.`,name:"cache_dir"},{anchor:"huggingface_hub.ModelHubMixin._from_pretrained.local_files_only",description:`<strong>local_files_only</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If <code>True</code>, avoid downloading the file and return the path to the local cached file if it exists.
model_kwargs &#x2014;
Additional keyword arguments passed along to the <a href="/docs/huggingface_hub/main/en/package_reference/mixins#huggingface_hub.ModelHubMixin._from_pretrained">_from_pretrained()</a> method.`,name:"local_files_only"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L187"}}),Pe=new A({props:{name:"from_pretrained",anchor:"huggingface_hub.ModelHubMixin.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, pathlib.Path]"},{name:"force_download",val:": bool = False"},{name:"resume_download",val:": bool = False"},{name:"proxies",val:": typing.Optional[typing.Dict] = None"},{name:"token",val:": typing.Union[str, bool, NoneType] = None"},{name:"cache_dir",val:": typing.Union[str, pathlib.Path, NoneType] = None"},{name:"local_files_only",val:": bool = False"},{name:"revision",val:": typing.Optional[str] = None"},{name:"**model_kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code>, <code>Path</code>) &#x2014;<ul>
<li>Either the <code>model_id</code> (string) of a model hosted on the Hub, e.g. <code>bigscience/bloom</code>.</li>
<li>Or a path to a <code>directory</code> containing model weights saved using
<a href="https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.save_pretrained" rel="nofollow">save_pretrained</a>, e.g., <code>../path/to/my_model_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Revision of the model on the Hub. Can be a branch name, a git tag or any commit id.
Defaults to the latest commit on <code>main</code> branch.`,name:"revision"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to force (re-)downloading the model weights and configuration files from the Hub, overriding
the existing cache.`,name:"force_download"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to delete incompletely received files. Will attempt to resume the download if such a file exists.`,name:"resume_download"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on every request.`,name:"proxies"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.token",description:`<strong>token</strong> (<code>str</code> or <code>bool</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. By default, it will use the token
cached when running <code>huggingface-cli login</code>.`,name:"token"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>str</code>, <code>Path</code>, <em>optional</em>) &#x2014;
Path to the folder where cached files are stored.`,name:"cache_dir"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.local_files_only",description:`<strong>local_files_only</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If <code>True</code>, avoid downloading the file and return the path to the local cached file if it exists.`,name:"local_files_only"},{anchor:"huggingface_hub.ModelHubMixin.from_pretrained.model_kwargs",description:`<strong>model_kwargs</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
Additional kwargs to pass to the model during initialization.`,name:"model_kwargs"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L90"}}),Te=new A({props:{name:"push_to_hub",anchor:"huggingface_hub.ModelHubMixin.push_to_hub",parameters:[{name:"repo_id",val:": str"},{name:"config",val:": typing.Optional[dict] = None"},{name:"commit_message",val:": str = 'Push model using huggingface_hub.'"},{name:"private",val:": bool = False"},{name:"api_endpoint",val:": typing.Optional[str] = None"},{name:"token",val:": typing.Optional[str] = None"},{name:"branch",val:": typing.Optional[str] = None"},{name:"create_pr",val:": typing.Optional[bool] = None"},{name:"allow_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"},{name:"ignore_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"}],parametersDescription:[{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.repo_id",description:`<strong>repo_id</strong> (<code>str</code>) &#x2014;
Repository name to which push.`,name:"repo_id"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Configuration object to be saved alongside the model weights.`,name:"config"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.commit_message",description:`<strong>commit_message</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Message to commit while pushing.`,name:"commit_message"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.private",description:`<strong>private</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the repository created should be private.`,name:"private"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.api_endpoint",description:`<strong>api_endpoint</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The API endpoint to use when pushing the model to the hub.`,name:"api_endpoint"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.token",description:`<strong>token</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. By default, it will use the token
cached when running <code>huggingface-cli login</code>.`,name:"token"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.branch",description:`<strong>branch</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The git branch on which to push the model. This defaults to <code>&quot;main&quot;</code>.`,name:"branch"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.create_pr",description:`<strong>create_pr</strong> (<code>boolean</code>, <em>optional</em>) &#x2014;
Whether or not to create a Pull Request from <code>branch</code> with that commit. Defaults to <code>False</code>.`,name:"create_pr"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.allow_patterns",description:`<strong>allow_patterns</strong> (<code>List[str]</code> or <code>str</code>, <em>optional</em>) &#x2014;
If provided, only files matching at least one pattern are pushed.`,name:"allow_patterns"},{anchor:"huggingface_hub.ModelHubMixin.push_to_hub.ignore_patterns",description:`<strong>ignore_patterns</strong> (<code>List[str]</code> or <code>str</code>, <em>optional</em>) &#x2014;
If provided, files matching any of the patterns are not pushed.`,name:"ignore_patterns"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L237",returnDescription:`
<p>The url of the commit of your model in the given repository.</p>
`}}),je=new A({props:{name:"save_pretrained",anchor:"huggingface_hub.ModelHubMixin.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, pathlib.Path]"},{name:"config",val:": typing.Optional[dict] = None"},{name:"repo_id",val:": typing.Optional[str] = None"},{name:"push_to_hub",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.ModelHubMixin.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>Path</code>) &#x2014;
Path to directory in which the model weights and configuration will be saved.`,name:"save_directory"},{anchor:"huggingface_hub.ModelHubMixin.save_pretrained.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Model configuration specified as a key/value dictionary.`,name:"config"},{anchor:"huggingface_hub.ModelHubMixin.save_pretrained.push_to_hub",description:`<strong>push_to_hub</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to push your model to the Huggingface Hub after saving it.`,name:"push_to_hub"},{anchor:"huggingface_hub.ModelHubMixin.save_pretrained.repo_id",description:`<strong>repo_id</strong> (<code>str</code>, <em>optional</em>) &#x2014;
ID of your repository on the Hub. Used only if <code>push_to_hub=True</code>. Will default to the folder name if
not provided.
kwargs &#x2014;
Additional key word arguments passed along to the <a href="/docs/huggingface_hub/main/en/package_reference/mixins#huggingface_hub.ModelHubMixin._from_pretrained">_from_pretrained()</a> method.`,name:"repo_id"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L34"}}),De=new co({}),Ne=new A({props:{name:"class huggingface_hub.PyTorchModelHubMixin",anchor:"huggingface_hub.PyTorchModelHubMixin",parameters:[],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/hub_mixin.py#L303"}}),de=new $r({props:{anchor:"huggingface_hub.PyTorchModelHubMixin.example",$$slots:{default:[Dr]},$$scope:{ctx:V}}}),Ae=new co({}),Ie=new A({props:{name:"class huggingface_hub.KerasModelHubMixin",anchor:"huggingface_hub.KerasModelHubMixin",parameters:[],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/keras_mixin.py#L417"}}),he=new $r({props:{anchor:"huggingface_hub.KerasModelHubMixin.example",$$slots:{default:[Nr]},$$scope:{ctx:V}}}),ze=new A({props:{name:"huggingface_hub.from_pretrained_keras",anchor:"huggingface_hub.from_pretrained_keras",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.from_pretrained_keras.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Can be either:<ul>
<li>A string, the <code>model id</code> of a pretrained model hosted inside a
model repo on huggingface.co. Valid model ids can be located
at the root-level, like <code>bert-base-uncased</code>, or namespaced
under a user or organization name, like
<code>dbmdz/bert-base-german-cased</code>.</li>
<li>You can add <code>revision</code> by appending <code>@</code> at the end of model_id
simply like this: <code>dbmdz/bert-base-german-cased@main</code> Revision
is the specific model version to use. It can be a branch name,
a tag name, or a commit id, since we use a git-based system
for storing models and other artifacts on huggingface.co, so
<code>revision</code> can be any identifier allowed by git.</li>
<li>A path to a <code>directory</code> containing model weights saved using
<a href="https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.save_pretrained" rel="nofollow">save_pretrained</a>, e.g.,
<code>./my_model_directory/</code>.</li>
<li><code>None</code> if you are both providing the configuration and state
dictionary (resp. with keyword arguments <code>config</code> and
<code>state_dict</code>).</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"huggingface_hub.from_pretrained_keras.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to force the (re-)download of the model weights and
configuration files, overriding the cached versions if they exist.`,name:"force_download"},{anchor:"huggingface_hub.from_pretrained_keras.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to delete incompletely received files. Will attempt to
resume the download if such a file exists.`,name:"resume_download"},{anchor:"huggingface_hub.from_pretrained_keras.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g.,
<code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The
proxies are used on each request.`,name:"proxies"},{anchor:"huggingface_hub.from_pretrained_keras.token",description:`<strong>token</strong> (<code>str</code> or <code>bool</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If
<code>True</code>, will use the token generated when running <code>transformers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"token"},{anchor:"huggingface_hub.from_pretrained_keras.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model
configuration should be cached if the standard cache should not be
used.`,name:"cache_dir"},{anchor:"huggingface_hub.from_pretrained_keras.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to only look at local files (i.e., do not try to download
the model).`,name:"local_files_only(bool,"},{anchor:"huggingface_hub.from_pretrained_keras.model_kwargs",description:`<strong>model_kwargs</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
model_kwargs will be passed to the model during initialization`,name:"model_kwargs"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/keras_mixin.py#L219"}}),ge=new xr({props:{$$slots:{default:[Ar]},$$scope:{ctx:V}}}),Se=new A({props:{name:"huggingface_hub.push_to_hub_keras",anchor:"huggingface_hub.push_to_hub_keras",parameters:[{name:"model",val:""},{name:"repo_id",val:": str"},{name:"config",val:": typing.Optional[dict] = None"},{name:"commit_message",val:": str = 'Push Keras model using huggingface_hub.'"},{name:"private",val:": bool = False"},{name:"api_endpoint",val:": typing.Optional[str] = None"},{name:"token",val:": typing.Optional[str] = None"},{name:"branch",val:": typing.Optional[str] = None"},{name:"create_pr",val:": typing.Optional[bool] = None"},{name:"allow_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"},{name:"ignore_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"},{name:"log_dir",val:": typing.Optional[str] = None"},{name:"include_optimizer",val:": bool = False"},{name:"tags",val:": typing.Union[list, str, NoneType] = None"},{name:"plot_model",val:": bool = True"},{name:"**model_save_kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.push_to_hub_keras.model",description:`<strong>model</strong> (<code>Keras.Model</code>) &#x2014;
The <a href="%60https://www.tensorflow.org/api_docs/python/tf/keras/Model%60">Keras model</a> you&#x2019;d like to push to the
Hub. The model must be compiled and built.`,name:"model"},{anchor:"huggingface_hub.push_to_hub_keras.repo_id",description:`<strong>repo_id</strong> (<code>str</code>) &#x2014;
Repository name to which push`,name:"repo_id"},{anchor:"huggingface_hub.push_to_hub_keras.commit_message",description:`<strong>commit_message</strong> (<code>str</code>, <em>optional</em>, defaults to &#x201C;Add Keras model&#x201D;) &#x2014;
Message to commit while pushing.`,name:"commit_message"},{anchor:"huggingface_hub.push_to_hub_keras.private",description:`<strong>private</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the repository created should be private.`,name:"private"},{anchor:"huggingface_hub.push_to_hub_keras.api_endpoint",description:`<strong>api_endpoint</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The API endpoint to use when pushing the model to the hub.`,name:"api_endpoint"},{anchor:"huggingface_hub.push_to_hub_keras.token",description:`<strong>token</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If
not set, will use the token set when logging in with
<code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"token"},{anchor:"huggingface_hub.push_to_hub_keras.branch",description:`<strong>branch</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The git branch on which to push the model. This defaults to
the default branch as specified in your repository, which
defaults to <code>&quot;main&quot;</code>.`,name:"branch"},{anchor:"huggingface_hub.push_to_hub_keras.create_pr",description:`<strong>create_pr</strong> (<code>boolean</code>, <em>optional</em>) &#x2014;
Whether or not to create a Pull Request from <code>branch</code> with that commit.
Defaults to <code>False</code>.`,name:"create_pr"},{anchor:"huggingface_hub.push_to_hub_keras.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Configuration object to be saved alongside the model weights.`,name:"config"},{anchor:"huggingface_hub.push_to_hub_keras.allow_patterns",description:`<strong>allow_patterns</strong> (<code>List[str]</code> or <code>str</code>, <em>optional</em>) &#x2014;
If provided, only files matching at least one pattern are pushed.`,name:"allow_patterns"},{anchor:"huggingface_hub.push_to_hub_keras.ignore_patterns",description:`<strong>ignore_patterns</strong> (<code>List[str]</code> or <code>str</code>, <em>optional</em>) &#x2014;
If provided, files matching any of the patterns are not pushed.`,name:"ignore_patterns"},{anchor:"huggingface_hub.push_to_hub_keras.log_dir",description:`<strong>log_dir</strong> (<code>str</code>, <em>optional</em>) &#x2014;
TensorBoard logging directory to be pushed. The Hub automatically
hosts and displays a TensorBoard instance if log files are included
in the repository.`,name:"log_dir"},{anchor:"huggingface_hub.push_to_hub_keras.include_optimizer",description:`<strong>include_optimizer</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to include optimizer during serialization.`,name:"include_optimizer"},{anchor:"huggingface_hub.push_to_hub_keras.tags",description:`<strong>tags</strong> (Union[<code>list</code>, <code>str</code>], <em>optional</em>) &#x2014;
List of tags that are related to model or string of a single tag. See example tags
<a href="https://github.com/huggingface/hub-docs/blame/main/modelcard.md" rel="nofollow">here</a>.`,name:"tags"},{anchor:"huggingface_hub.push_to_hub_keras.plot_model",description:`<strong>plot_model</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Setting this to <code>True</code> will plot the model and put it in the model
card. Requires graphviz and pydot to be installed.`,name:"plot_model"},{anchor:"huggingface_hub.push_to_hub_keras.model_save_kwargs(dict,",description:`<strong>model_save_kwargs(<code>dict</code>,</strong> <em>optional</em>) &#x2014;
model_save_kwargs will be passed to
<a href="https://www.tensorflow.org/api_docs/python/tf/keras/models/save_model" rel="nofollow"><code>tf.keras.models.save_model()</code></a>.`,name:"model_save_kwargs(dict,"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/keras_mixin.py#L278",returnDescription:`
<p>The url of the commit of your model in the given repository.</p>
`}}),Ce=new A({props:{name:"huggingface_hub.save_pretrained_keras",anchor:"huggingface_hub.save_pretrained_keras",parameters:[{name:"model",val:""},{name:"save_directory",val:": typing.Union[str, pathlib.Path]"},{name:"config",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"include_optimizer",val:": bool = False"},{name:"plot_model",val:": bool = True"},{name:"tags",val:": typing.Union[list, str, NoneType] = None"},{name:"**model_save_kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.save_pretrained_keras.model",description:`<strong>model</strong> (<code>Keras.Model</code>) &#x2014;
The <a href="https://www.tensorflow.org/api_docs/python/tf/keras/Model" rel="nofollow">Keras
model</a>
you&#x2019;d like to save. The model must be compiled and built.`,name:"model"},{anchor:"huggingface_hub.save_pretrained_keras.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>Path</code>) &#x2014;
Specify directory in which you want to save the Keras model.`,name:"save_directory"},{anchor:"huggingface_hub.save_pretrained_keras.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Configuration object to be saved alongside the model weights.`,name:"config"},{anchor:"huggingface_hub.save_pretrained_keras.include_optimizer(bool,",description:`<strong>include_optimizer(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to include optimizer in serialization.`,name:"include_optimizer(bool,"},{anchor:"huggingface_hub.save_pretrained_keras.plot_model",description:`<strong>plot_model</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Setting this to <code>True</code> will plot the model and put it in the model
card. Requires graphviz and pydot to be installed.`,name:"plot_model"},{anchor:"huggingface_hub.save_pretrained_keras.tags",description:`<strong>tags</strong> (Union[<code>str</code>,<code>list</code>], <em>optional</em>) &#x2014;
List of tags that are related to model or string of a single tag. See example tags
<a href="https://github.com/huggingface/hub-docs/blame/main/modelcard.md" rel="nofollow">here</a>.`,name:"tags"},{anchor:"huggingface_hub.save_pretrained_keras.model_save_kwargs(dict,",description:`<strong>model_save_kwargs(<code>dict</code>,</strong> <em>optional</em>) &#x2014;
model_save_kwargs will be passed to
<a href="https://www.tensorflow.org/api_docs/python/tf/keras/models/save_model" rel="nofollow"><code>tf.keras.models.save_model()</code></a>.`,name:"model_save_kwargs(dict,"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/keras_mixin.py#L134"}}),Ue=new co({}),qe=new A({props:{name:"huggingface_hub.from_pretrained_fastai",anchor:"huggingface_hub.from_pretrained_fastai",parameters:[{name:"repo_id",val:": str"},{name:"revision",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"huggingface_hub.from_pretrained_fastai.repo_id",description:`<strong>repo_id</strong> (<code>str</code>) &#x2014;
The location where the pickled fastai.Learner is. It can be either of the two:<ul>
<li>Hosted on the Hugging Face Hub. E.g.: &#x2018;espejelomar/fatai-pet-breeds-classification&#x2019; or &#x2018;distilgpt2&#x2019;.
You can add a <code>revision</code> by appending <code>@</code> at the end of <code>repo_id</code>. E.g.: <code>dbmdz/bert-base-german-cased@main</code>.
Revision is the specific model version to use. Since we use a git-based system for storing models and other
artifacts on the Hugging Face Hub, it can be a branch name, a tag name, or a commit id.</li>
<li>Hosted locally. <code>repo_id</code> would be a directory containing the pickle and a pyproject.toml
indicating the fastai and fastcore versions used to build the <code>fastai.Learner</code>. E.g.: <code>./my_model_directory/</code>.</li>
</ul>`,name:"repo_id"},{anchor:"huggingface_hub.from_pretrained_fastai.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Revision at which the repo&#x2019;s files are downloaded. See documentation of <code>snapshot_download</code>.`,name:"revision"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/fastai_utils.py#L298",returnDescription:`
<p>The <code>fastai.Learner</code> model in the <code>repo_id</code> repo.</p>
`}}),Ke=new A({props:{name:"huggingface_hub.push_to_hub_fastai",anchor:"huggingface_hub.push_to_hub_fastai",parameters:[{name:"learner",val:""},{name:"repo_id",val:": str"},{name:"commit_message",val:": str = 'Push FastAI model using huggingface_hub.'"},{name:"private",val:": bool = False"},{name:"token",val:": typing.Optional[str] = None"},{name:"config",val:": typing.Optional[dict] = None"},{name:"branch",val:": typing.Optional[str] = None"},{name:"create_pr",val:": typing.Optional[bool] = None"},{name:"allow_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"},{name:"ignore_patterns",val:": typing.Union[typing.List[str], str, NoneType] = None"},{name:"api_endpoint",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"huggingface_hub.push_to_hub_fastai.learner",description:`<strong>learner</strong> (<em>Learner</em>) &#x2014;
The *fastai.Learner&#x2019; you&#x2019;d like to push to the Hub.`,name:"learner"},{anchor:"huggingface_hub.push_to_hub_fastai.repo_id",description:`<strong>repo_id</strong> (<em>str</em>) &#x2014;
The repository id for your model in Hub in the format of &#x201C;namespace/repo_name&#x201D;. The namespace can be your individual account or an organization to which you have write access (for example, &#x2018;stanfordnlp/stanza-de&#x2019;).`,name:"repo_id"},{anchor:"huggingface_hub.push_to_hub_fastai.commit_message",description:"<strong>commit_message</strong> (<em>str`, </em>optional*) &#x2014; Message to commit while pushing. Will default to <code>&quot;add model&quot;</code>.",name:"commit_message"},{anchor:"huggingface_hub.push_to_hub_fastai.private",description:`<strong>private</strong> (<em>bool</em>, <em>optional</em>, defaults to <em>False</em>) &#x2014;
Whether or not the repository created should be private.`,name:"private"},{anchor:"huggingface_hub.push_to_hub_fastai.token",description:`<strong>token</strong> (<em>str</em>, <em>optional</em>) &#x2014;
The Hugging Face account token to use as HTTP bearer authorization for remote files. If <code>None</code>, the token will be asked by a prompt.`,name:"token"},{anchor:"huggingface_hub.push_to_hub_fastai.config",description:`<strong>config</strong> (<em>dict</em>, <em>optional</em>) &#x2014;
Configuration object to be saved alongside the model weights.`,name:"config"},{anchor:"huggingface_hub.push_to_hub_fastai.branch",description:`<strong>branch</strong> (<em>str</em>, <em>optional</em>) &#x2014;
The git branch on which to push the model. This defaults to
the default branch as specified in your repository, which
defaults to <em>&#x201C;main&#x201D;</em>.`,name:"branch"},{anchor:"huggingface_hub.push_to_hub_fastai.create_pr",description:`<strong>create_pr</strong> (<em>boolean</em>, <em>optional</em>) &#x2014;
Whether or not to create a Pull Request from <em>branch</em> with that commit.
Defaults to <em>False</em>.`,name:"create_pr"},{anchor:"huggingface_hub.push_to_hub_fastai.api_endpoint",description:`<strong>api_endpoint</strong> (<em>str</em>, <em>optional</em>) &#x2014;
The API endpoint to use when pushing the model to the hub.`,name:"api_endpoint"},{anchor:"huggingface_hub.push_to_hub_fastai.allow_patterns",description:`<strong>allow_patterns</strong> (<em>List[str]</em> or <em>str</em>, <em>optional</em>) &#x2014;
If provided, only files matching at least one pattern are pushed.`,name:"allow_patterns"},{anchor:"huggingface_hub.push_to_hub_fastai.ignore_patterns",description:`<strong>ignore_patterns</strong> (<em>List[str]</em> or <em>str</em>, <em>optional</em>) &#x2014;
If provided, files matching any of the patterns are not pushed.`,name:"ignore_patterns"}],source:"https://github.com/huggingface/huggingface_hub/blob/main/src/huggingface_hub/fastai_utils.py#L343",returnDescription:`
<p>The url of the commit of your model in the given repository.</p>
`}}),me=new xr({props:{$$slots:{default:[Ir]},$$scope:{ctx:V}}}),{c(){g=a("meta"),k=d(),u=a("h1"),f=a("a"),M=a("span"),_(p.$$.fragment),$=d(),I=a("span"),we=s("Mixins & serialization methods"),E=d(),P=a("h2"),z=a("a"),Q=a("span"),_(R.$$.fragment),Ve=d(),ho=a("span"),xt=s("Mixins"),Bo=d(),B=a("p"),$t=s("The "),go=a("code"),kt=s("huggingface_hub"),Mt=s(` library offers a range of mixins that can be used as a parent class for your objects, in order to
provide simple uploading and downloading functions. Check out our `),Re=a("a"),Ht=s("integration guide"),Et=s(` to learn
how to integrate any ML framework with the Hub.`),Go=d(),X=a("h3"),ne=a("a"),po=a("span"),_(xe.$$.fragment),Pt=d(),mo=a("span"),Tt=s("Generic"),Yo=d(),H=a("div"),_($e.$$.fragment),jt=d(),uo=a("p"),Dt=s("A generic mixin to integrate ANY machine learning framework with the Hub."),Nt=d(),j=a("p"),At=s(`To integrate your framework, your model class must inherit from this class. Custom logic for saving/loading models
have to be overwritten in  `),fo=a("code"),It=s("_from_pretrained"),Lt=s(" and "),_o=a("code"),zt=s("_save_pretrained"),Ot=s(". "),Be=a("a"),St=s("PyTorchModelHubMixin"),Ft=s(` is a good example
of mixin integration with the Hub. Check out our `),Ge=a("a"),Ct=s("integration guide"),Ut=s(" for more instructions."),qt=d(),re=a("div"),_(ke.$$.fragment),Kt=d(),Me=a("p"),Wt=s(`Overwrite this method in subclass to define how to save your model.
Check out our `),Ye=a("a"),Vt=s("integration guide"),Rt=s(" for instructions."),Bt=d(),L=a("div"),_(He.$$.fragment),Gt=d(),bo=a("p"),Yt=s("Overwrite this method in subclass to define how to load your model from pretrained."),Jt=d(),D=a("p"),Qt=s("Use "),Je=a("a"),Xt=s("hf_hub_download()"),Zt=s(" or "),Qe=a("a"),ea=s("snapshot_download()"),oa=s(` to download files from the Hub before loading them. Most
args taken as input can be directly passed to those 2 methods. If needed, you can add more arguments to this
method using \u201Cmodel_kwargs\u201D. For example `),vo=a("code"),ta=s("PyTorchModelHubMixin._from_pretrained()"),aa=s(" takes as input a "),yo=a("code"),na=s("map_location"),ra=s(`
parameter to set on which device the model should be loaded.`),sa=d(),Ee=a("p"),ia=s("Check out our "),Xe=a("a"),la=s("integration guide"),da=s(" for more instructions."),ca=d(),se=a("div"),_(Pe.$$.fragment),ha=d(),wo=a("p"),ga=s("Download a model from the Huggingface Hub and instantiate it."),pa=d(),G=a("div"),_(Te.$$.fragment),ma=d(),xo=a("p"),ua=s("Upload model checkpoint to the Hub."),fa=d(),O=a("p"),_a=s("Use "),$o=a("code"),ba=s("allow_patterns"),va=s(" and "),ko=a("code"),ya=s("ignore_patterns"),wa=s(` to precisely filter which files should be pushed to the hub. See
`),Ze=a("a"),xa=s("upload_folder()"),$a=s(" reference for more details."),ka=d(),ie=a("div"),_(je.$$.fragment),Ma=d(),Mo=a("p"),Ha=s("Save weights in local directory."),Jo=d(),Z=a("h3"),le=a("a"),Ho=a("span"),_(De.$$.fragment),Ea=d(),Eo=a("span"),Pa=s("PyTorch"),Qo=d(),S=a("div"),_(Ne.$$.fragment),Ta=d(),F=a("p"),ja=s("Implementation of "),eo=a("a"),Da=s("ModelHubMixin"),Na=s(` to provide model Hub upload/download capabilities to PyTorch models. The model
is set in evaluation mode by default using `),Po=a("code"),Aa=s("model.eval()"),Ia=s(` (dropout modules are deactivated). To train the model,
you should first set it back in training mode with `),To=a("code"),La=s("model.train()"),za=s("."),Oa=d(),_(de.$$.fragment),Xo=d(),ee=a("h3"),ce=a("a"),jo=a("span"),_(Ae.$$.fragment),Sa=d(),Do=a("span"),Fa=s("Keras"),Zo=d(),C=a("div"),_(Ie.$$.fragment),Ca=d(),Le=a("p"),Ua=s("Implementation of "),oo=a("a"),qa=s("ModelHubMixin"),Ka=s(` to provide model Hub upload/download
capabilities to Keras models.`),Wa=d(),_(he.$$.fragment),et=d(),U=a("div"),_(ze.$$.fragment),Va=d(),Oe=a("p"),Ra=s(`Instantiate a pretrained Keras model from a pre-trained model from the Hub.
The model is expected to be in `),No=a("code"),Ba=s("SavedModel"),Ga=s(" format."),Ya=d(),_(ge.$$.fragment),ot=d(),q=a("div"),_(Se.$$.fragment),Ja=d(),Fe=a("p"),Qa=s(`Upload model checkpoint or tokenizer files to the Hub while synchronizing a
local clone of the repo in `),Ao=a("code"),Xa=s("repo_path_or_name"),Za=s("."),en=d(),K=a("p"),on=s("Use "),Io=a("code"),tn=s("allow_patterns"),an=s(" and "),Lo=a("code"),nn=s("ignore_patterns"),rn=s(` to precisely filter which files should be
pushed to the hub. See `),to=a("a"),sn=s("upload_folder()"),ln=s(" reference for more details."),tt=d(),oe=a("div"),_(Ce.$$.fragment),dn=d(),zo=a("p"),cn=s(`Saves a Keras model to save_directory in SavedModel format. Use this if
you\u2019re using the Functional or Sequential APIs.`),at=d(),te=a("h3"),pe=a("a"),Oo=a("span"),_(Ue.$$.fragment),hn=d(),So=a("span"),gn=s("Fastai"),nt=d(),ae=a("div"),_(qe.$$.fragment),pn=d(),Fo=a("p"),mn=s("Load pretrained fastai model from the Hub or from a local directory."),rt=d(),N=a("div"),_(Ke.$$.fragment),un=d(),Co=a("p"),fn=s("Upload learner checkpoint files to the Hub."),_n=d(),W=a("p"),bn=s("Use "),Uo=a("em"),vn=s("allow_patterns"),yn=s(" and "),qo=a("em"),wn=s("ignore_patterns"),xn=s(` to precisely filter which files should be
pushed to the hub. See [`),Ko=a("em"),$n=s("upload_folder"),kn=s("] reference for more details."),Mn=d(),_(me.$$.fragment),this.h()},l(o){const h=Tr('[data-svelte="svelte-1phssyn"]',document.head);g=n(h,"META",{name:!0,content:!0}),h.forEach(t),k=c(o),u=n(o,"H1",{class:!0});var We=r(u);f=n(We,"A",{id:!0,class:!0,href:!0});var Wo=r(f);M=n(Wo,"SPAN",{});var Vo=r(M);b(p.$$.fragment,Vo),Vo.forEach(t),Wo.forEach(t),$=c(We),I=n(We,"SPAN",{});var Ro=r(I);we=i(Ro,"Mixins & serialization methods"),Ro.forEach(t),We.forEach(t),E=c(o),P=n(o,"H2",{class:!0});var it=r(P);z=n(it,"A",{id:!0,class:!0,href:!0});var Hn=r(z);Q=n(Hn,"SPAN",{});var En=r(Q);b(R.$$.fragment,En),En.forEach(t),Hn.forEach(t),Ve=c(it),ho=n(it,"SPAN",{});var Pn=r(ho);xt=i(Pn,"Mixins"),Pn.forEach(t),it.forEach(t),Bo=c(o),B=n(o,"P",{});var ao=r(B);$t=i(ao,"The "),go=n(ao,"CODE",{});var Tn=r(go);kt=i(Tn,"huggingface_hub"),Tn.forEach(t),Mt=i(ao,` library offers a range of mixins that can be used as a parent class for your objects, in order to
provide simple uploading and downloading functions. Check out our `),Re=n(ao,"A",{href:!0});var jn=r(Re);Ht=i(jn,"integration guide"),jn.forEach(t),Et=i(ao,` to learn
how to integrate any ML framework with the Hub.`),ao.forEach(t),Go=c(o),X=n(o,"H3",{class:!0});var lt=r(X);ne=n(lt,"A",{id:!0,class:!0,href:!0});var Dn=r(ne);po=n(Dn,"SPAN",{});var Nn=r(po);b(xe.$$.fragment,Nn),Nn.forEach(t),Dn.forEach(t),Pt=c(lt),mo=n(lt,"SPAN",{});var An=r(mo);Tt=i(An,"Generic"),An.forEach(t),lt.forEach(t),Yo=c(o),H=n(o,"DIV",{class:!0});var T=r(H);b($e.$$.fragment,T),jt=c(T),uo=n(T,"P",{});var In=r(uo);Dt=i(In,"A generic mixin to integrate ANY machine learning framework with the Hub."),In.forEach(t),Nt=c(T),j=n(T,"P",{});var Y=r(j);At=i(Y,`To integrate your framework, your model class must inherit from this class. Custom logic for saving/loading models
have to be overwritten in  `),fo=n(Y,"CODE",{});var Ln=r(fo);It=i(Ln,"_from_pretrained"),Ln.forEach(t),Lt=i(Y," and "),_o=n(Y,"CODE",{});var zn=r(_o);zt=i(zn,"_save_pretrained"),zn.forEach(t),Ot=i(Y,". "),Be=n(Y,"A",{href:!0});var On=r(Be);St=i(On,"PyTorchModelHubMixin"),On.forEach(t),Ft=i(Y,` is a good example
of mixin integration with the Hub. Check out our `),Ge=n(Y,"A",{href:!0});var Sn=r(Ge);Ct=i(Sn,"integration guide"),Sn.forEach(t),Ut=i(Y," for more instructions."),Y.forEach(t),qt=c(T),re=n(T,"DIV",{class:!0});var dt=r(re);b(ke.$$.fragment,dt),Kt=c(dt),Me=n(dt,"P",{});var ct=r(Me);Wt=i(ct,`Overwrite this method in subclass to define how to save your model.
Check out our `),Ye=n(ct,"A",{href:!0});var Fn=r(Ye);Vt=i(Fn,"integration guide"),Fn.forEach(t),Rt=i(ct," for instructions."),ct.forEach(t),dt.forEach(t),Bt=c(T),L=n(T,"DIV",{class:!0});var ue=r(L);b(He.$$.fragment,ue),Gt=c(ue),bo=n(ue,"P",{});var Cn=r(bo);Yt=i(Cn,"Overwrite this method in subclass to define how to load your model from pretrained."),Cn.forEach(t),Jt=c(ue),D=n(ue,"P",{});var J=r(D);Qt=i(J,"Use "),Je=n(J,"A",{href:!0});var Un=r(Je);Xt=i(Un,"hf_hub_download()"),Un.forEach(t),Zt=i(J," or "),Qe=n(J,"A",{href:!0});var qn=r(Qe);ea=i(qn,"snapshot_download()"),qn.forEach(t),oa=i(J,` to download files from the Hub before loading them. Most
args taken as input can be directly passed to those 2 methods. If needed, you can add more arguments to this
method using \u201Cmodel_kwargs\u201D. For example `),vo=n(J,"CODE",{});var Kn=r(vo);ta=i(Kn,"PyTorchModelHubMixin._from_pretrained()"),Kn.forEach(t),aa=i(J," takes as input a "),yo=n(J,"CODE",{});var Wn=r(yo);na=i(Wn,"map_location"),Wn.forEach(t),ra=i(J,`
parameter to set on which device the model should be loaded.`),J.forEach(t),sa=c(ue),Ee=n(ue,"P",{});var ht=r(Ee);ia=i(ht,"Check out our "),Xe=n(ht,"A",{href:!0});var Vn=r(Xe);la=i(Vn,"integration guide"),Vn.forEach(t),da=i(ht," for more instructions."),ht.forEach(t),ue.forEach(t),ca=c(T),se=n(T,"DIV",{class:!0});var gt=r(se);b(Pe.$$.fragment,gt),ha=c(gt),wo=n(gt,"P",{});var Rn=r(wo);ga=i(Rn,"Download a model from the Huggingface Hub and instantiate it."),Rn.forEach(t),gt.forEach(t),pa=c(T),G=n(T,"DIV",{class:!0});var no=r(G);b(Te.$$.fragment,no),ma=c(no),xo=n(no,"P",{});var Bn=r(xo);ua=i(Bn,"Upload model checkpoint to the Hub."),Bn.forEach(t),fa=c(no),O=n(no,"P",{});var fe=r(O);_a=i(fe,"Use "),$o=n(fe,"CODE",{});var Gn=r($o);ba=i(Gn,"allow_patterns"),Gn.forEach(t),va=i(fe," and "),ko=n(fe,"CODE",{});var Yn=r(ko);ya=i(Yn,"ignore_patterns"),Yn.forEach(t),wa=i(fe,` to precisely filter which files should be pushed to the hub. See
`),Ze=n(fe,"A",{href:!0});var Jn=r(Ze);xa=i(Jn,"upload_folder()"),Jn.forEach(t),$a=i(fe," reference for more details."),fe.forEach(t),no.forEach(t),ka=c(T),ie=n(T,"DIV",{class:!0});var pt=r(ie);b(je.$$.fragment,pt),Ma=c(pt),Mo=n(pt,"P",{});var Qn=r(Mo);Ha=i(Qn,"Save weights in local directory."),Qn.forEach(t),pt.forEach(t),T.forEach(t),Jo=c(o),Z=n(o,"H3",{class:!0});var mt=r(Z);le=n(mt,"A",{id:!0,class:!0,href:!0});var Xn=r(le);Ho=n(Xn,"SPAN",{});var Zn=r(Ho);b(De.$$.fragment,Zn),Zn.forEach(t),Xn.forEach(t),Ea=c(mt),Eo=n(mt,"SPAN",{});var er=r(Eo);Pa=i(er,"PyTorch"),er.forEach(t),mt.forEach(t),Qo=c(o),S=n(o,"DIV",{class:!0});var ro=r(S);b(Ne.$$.fragment,ro),Ta=c(ro),F=n(ro,"P",{});var _e=r(F);ja=i(_e,"Implementation of "),eo=n(_e,"A",{href:!0});var or=r(eo);Da=i(or,"ModelHubMixin"),or.forEach(t),Na=i(_e,` to provide model Hub upload/download capabilities to PyTorch models. The model
is set in evaluation mode by default using `),Po=n(_e,"CODE",{});var tr=r(Po);Aa=i(tr,"model.eval()"),tr.forEach(t),Ia=i(_e,` (dropout modules are deactivated). To train the model,
you should first set it back in training mode with `),To=n(_e,"CODE",{});var ar=r(To);La=i(ar,"model.train()"),ar.forEach(t),za=i(_e,"."),_e.forEach(t),Oa=c(ro),b(de.$$.fragment,ro),ro.forEach(t),Xo=c(o),ee=n(o,"H3",{class:!0});var ut=r(ee);ce=n(ut,"A",{id:!0,class:!0,href:!0});var nr=r(ce);jo=n(nr,"SPAN",{});var rr=r(jo);b(Ae.$$.fragment,rr),rr.forEach(t),nr.forEach(t),Sa=c(ut),Do=n(ut,"SPAN",{});var sr=r(Do);Fa=i(sr,"Keras"),sr.forEach(t),ut.forEach(t),Zo=c(o),C=n(o,"DIV",{class:!0});var so=r(C);b(Ie.$$.fragment,so),Ca=c(so),Le=n(so,"P",{});var ft=r(Le);Ua=i(ft,"Implementation of "),oo=n(ft,"A",{href:!0});var ir=r(oo);qa=i(ir,"ModelHubMixin"),ir.forEach(t),Ka=i(ft,` to provide model Hub upload/download
capabilities to Keras models.`),ft.forEach(t),Wa=c(so),b(he.$$.fragment,so),so.forEach(t),et=c(o),U=n(o,"DIV",{class:!0});var io=r(U);b(ze.$$.fragment,io),Va=c(io),Oe=n(io,"P",{});var _t=r(Oe);Ra=i(_t,`Instantiate a pretrained Keras model from a pre-trained model from the Hub.
The model is expected to be in `),No=n(_t,"CODE",{});var lr=r(No);Ba=i(lr,"SavedModel"),lr.forEach(t),Ga=i(_t," format."),_t.forEach(t),Ya=c(io),b(ge.$$.fragment,io),io.forEach(t),ot=c(o),q=n(o,"DIV",{class:!0});var lo=r(q);b(Se.$$.fragment,lo),Ja=c(lo),Fe=n(lo,"P",{});var bt=r(Fe);Qa=i(bt,`Upload model checkpoint or tokenizer files to the Hub while synchronizing a
local clone of the repo in `),Ao=n(bt,"CODE",{});var dr=r(Ao);Xa=i(dr,"repo_path_or_name"),dr.forEach(t),Za=i(bt,"."),bt.forEach(t),en=c(lo),K=n(lo,"P",{});var be=r(K);on=i(be,"Use "),Io=n(be,"CODE",{});var cr=r(Io);tn=i(cr,"allow_patterns"),cr.forEach(t),an=i(be," and "),Lo=n(be,"CODE",{});var hr=r(Lo);nn=i(hr,"ignore_patterns"),hr.forEach(t),rn=i(be,` to precisely filter which files should be
pushed to the hub. See `),to=n(be,"A",{href:!0});var gr=r(to);sn=i(gr,"upload_folder()"),gr.forEach(t),ln=i(be," reference for more details."),be.forEach(t),lo.forEach(t),tt=c(o),oe=n(o,"DIV",{class:!0});var vt=r(oe);b(Ce.$$.fragment,vt),dn=c(vt),zo=n(vt,"P",{});var pr=r(zo);cn=i(pr,`Saves a Keras model to save_directory in SavedModel format. Use this if
you\u2019re using the Functional or Sequential APIs.`),pr.forEach(t),vt.forEach(t),at=c(o),te=n(o,"H3",{class:!0});var yt=r(te);pe=n(yt,"A",{id:!0,class:!0,href:!0});var mr=r(pe);Oo=n(mr,"SPAN",{});var ur=r(Oo);b(Ue.$$.fragment,ur),ur.forEach(t),mr.forEach(t),hn=c(yt),So=n(yt,"SPAN",{});var fr=r(So);gn=i(fr,"Fastai"),fr.forEach(t),yt.forEach(t),nt=c(o),ae=n(o,"DIV",{class:!0});var wt=r(ae);b(qe.$$.fragment,wt),pn=c(wt),Fo=n(wt,"P",{});var _r=r(Fo);mn=i(_r,"Load pretrained fastai model from the Hub or from a local directory."),_r.forEach(t),wt.forEach(t),rt=c(o),N=n(o,"DIV",{class:!0});var ve=r(N);b(Ke.$$.fragment,ve),un=c(ve),Co=n(ve,"P",{});var br=r(Co);fn=i(br,"Upload learner checkpoint files to the Hub."),br.forEach(t),_n=c(ve),W=n(ve,"P",{});var ye=r(W);bn=i(ye,"Use "),Uo=n(ye,"EM",{});var vr=r(Uo);vn=i(vr,"allow_patterns"),vr.forEach(t),yn=i(ye," and "),qo=n(ye,"EM",{});var yr=r(qo);wn=i(yr,"ignore_patterns"),yr.forEach(t),xn=i(ye,` to precisely filter which files should be
pushed to the hub. See [`),Ko=n(ye,"EM",{});var wr=r(Ko);$n=i(wr,"upload_folder"),wr.forEach(t),kn=i(ye,"] reference for more details."),ye.forEach(t),Mn=c(ve),b(me.$$.fragment,ve),ve.forEach(t),this.h()},h(){l(g,"name","hf:doc:metadata"),l(g,"content",JSON.stringify(zr)),l(f,"id","mixins-serialization-methods"),l(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(f,"href","#mixins-serialization-methods"),l(u,"class","relative group"),l(z,"id","mixins"),l(z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(z,"href","#mixins"),l(P,"class","relative group"),l(Re,"href","../guides/integrations"),l(ne,"id","huggingface_hub.ModelHubMixin"),l(ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ne,"href","#huggingface_hub.ModelHubMixin"),l(X,"class","relative group"),l(Be,"href","/docs/huggingface_hub/main/en/package_reference/mixins#huggingface_hub.PyTorchModelHubMixin"),l(Ge,"href","../guides/integrations"),l(Ye,"href","../guides/integrations"),l(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Je,"href","/docs/huggingface_hub/main/en/package_reference/file_download#huggingface_hub.hf_hub_download"),l(Qe,"href","/docs/huggingface_hub/main/en/package_reference/file_download#huggingface_hub.snapshot_download"),l(Xe,"href","../guides/integrations"),l(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ze,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi.upload_folder"),l(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(le,"id","huggingface_hub.PyTorchModelHubMixin"),l(le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(le,"href","#huggingface_hub.PyTorchModelHubMixin"),l(Z,"class","relative group"),l(eo,"href","/docs/huggingface_hub/main/en/package_reference/mixins#huggingface_hub.ModelHubMixin"),l(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ce,"id","huggingface_hub.KerasModelHubMixin"),l(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ce,"href","#huggingface_hub.KerasModelHubMixin"),l(ee,"class","relative group"),l(oo,"href","/docs/huggingface_hub/main/en/package_reference/mixins#huggingface_hub.ModelHubMixin"),l(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(to,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi.upload_folder"),l(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(pe,"id","huggingface_hub.from_pretrained_fastai"),l(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(pe,"href","#huggingface_hub.from_pretrained_fastai"),l(te,"class","relative group"),l(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,h){e(document.head,g),m(o,k,h),m(o,u,h),e(u,f),e(f,M),v(p,M,null),e(u,$),e(u,I),e(I,we),m(o,E,h),m(o,P,h),e(P,z),e(z,Q),v(R,Q,null),e(P,Ve),e(P,ho),e(ho,xt),m(o,Bo,h),m(o,B,h),e(B,$t),e(B,go),e(go,kt),e(B,Mt),e(B,Re),e(Re,Ht),e(B,Et),m(o,Go,h),m(o,X,h),e(X,ne),e(ne,po),v(xe,po,null),e(X,Pt),e(X,mo),e(mo,Tt),m(o,Yo,h),m(o,H,h),v($e,H,null),e(H,jt),e(H,uo),e(uo,Dt),e(H,Nt),e(H,j),e(j,At),e(j,fo),e(fo,It),e(j,Lt),e(j,_o),e(_o,zt),e(j,Ot),e(j,Be),e(Be,St),e(j,Ft),e(j,Ge),e(Ge,Ct),e(j,Ut),e(H,qt),e(H,re),v(ke,re,null),e(re,Kt),e(re,Me),e(Me,Wt),e(Me,Ye),e(Ye,Vt),e(Me,Rt),e(H,Bt),e(H,L),v(He,L,null),e(L,Gt),e(L,bo),e(bo,Yt),e(L,Jt),e(L,D),e(D,Qt),e(D,Je),e(Je,Xt),e(D,Zt),e(D,Qe),e(Qe,ea),e(D,oa),e(D,vo),e(vo,ta),e(D,aa),e(D,yo),e(yo,na),e(D,ra),e(L,sa),e(L,Ee),e(Ee,ia),e(Ee,Xe),e(Xe,la),e(Ee,da),e(H,ca),e(H,se),v(Pe,se,null),e(se,ha),e(se,wo),e(wo,ga),e(H,pa),e(H,G),v(Te,G,null),e(G,ma),e(G,xo),e(xo,ua),e(G,fa),e(G,O),e(O,_a),e(O,$o),e($o,ba),e(O,va),e(O,ko),e(ko,ya),e(O,wa),e(O,Ze),e(Ze,xa),e(O,$a),e(H,ka),e(H,ie),v(je,ie,null),e(ie,Ma),e(ie,Mo),e(Mo,Ha),m(o,Jo,h),m(o,Z,h),e(Z,le),e(le,Ho),v(De,Ho,null),e(Z,Ea),e(Z,Eo),e(Eo,Pa),m(o,Qo,h),m(o,S,h),v(Ne,S,null),e(S,Ta),e(S,F),e(F,ja),e(F,eo),e(eo,Da),e(F,Na),e(F,Po),e(Po,Aa),e(F,Ia),e(F,To),e(To,La),e(F,za),e(S,Oa),v(de,S,null),m(o,Xo,h),m(o,ee,h),e(ee,ce),e(ce,jo),v(Ae,jo,null),e(ee,Sa),e(ee,Do),e(Do,Fa),m(o,Zo,h),m(o,C,h),v(Ie,C,null),e(C,Ca),e(C,Le),e(Le,Ua),e(Le,oo),e(oo,qa),e(Le,Ka),e(C,Wa),v(he,C,null),m(o,et,h),m(o,U,h),v(ze,U,null),e(U,Va),e(U,Oe),e(Oe,Ra),e(Oe,No),e(No,Ba),e(Oe,Ga),e(U,Ya),v(ge,U,null),m(o,ot,h),m(o,q,h),v(Se,q,null),e(q,Ja),e(q,Fe),e(Fe,Qa),e(Fe,Ao),e(Ao,Xa),e(Fe,Za),e(q,en),e(q,K),e(K,on),e(K,Io),e(Io,tn),e(K,an),e(K,Lo),e(Lo,nn),e(K,rn),e(K,to),e(to,sn),e(K,ln),m(o,tt,h),m(o,oe,h),v(Ce,oe,null),e(oe,dn),e(oe,zo),e(zo,cn),m(o,at,h),m(o,te,h),e(te,pe),e(pe,Oo),v(Ue,Oo,null),e(te,hn),e(te,So),e(So,gn),m(o,nt,h),m(o,ae,h),v(qe,ae,null),e(ae,pn),e(ae,Fo),e(Fo,mn),m(o,rt,h),m(o,N,h),v(Ke,N,null),e(N,un),e(N,Co),e(Co,fn),e(N,_n),e(N,W),e(W,bn),e(W,Uo),e(Uo,vn),e(W,yn),e(W,qo),e(qo,wn),e(W,xn),e(W,Ko),e(Ko,$n),e(W,kn),e(N,Mn),v(me,N,null),st=!0},p(o,[h]){const We={};h&2&&(We.$$scope={dirty:h,ctx:o}),de.$set(We);const Wo={};h&2&&(Wo.$$scope={dirty:h,ctx:o}),he.$set(Wo);const Vo={};h&2&&(Vo.$$scope={dirty:h,ctx:o}),ge.$set(Vo);const Ro={};h&2&&(Ro.$$scope={dirty:h,ctx:o}),me.$set(Ro)},i(o){st||(y(p.$$.fragment,o),y(R.$$.fragment,o),y(xe.$$.fragment,o),y($e.$$.fragment,o),y(ke.$$.fragment,o),y(He.$$.fragment,o),y(Pe.$$.fragment,o),y(Te.$$.fragment,o),y(je.$$.fragment,o),y(De.$$.fragment,o),y(Ne.$$.fragment,o),y(de.$$.fragment,o),y(Ae.$$.fragment,o),y(Ie.$$.fragment,o),y(he.$$.fragment,o),y(ze.$$.fragment,o),y(ge.$$.fragment,o),y(Se.$$.fragment,o),y(Ce.$$.fragment,o),y(Ue.$$.fragment,o),y(qe.$$.fragment,o),y(Ke.$$.fragment,o),y(me.$$.fragment,o),st=!0)},o(o){w(p.$$.fragment,o),w(R.$$.fragment,o),w(xe.$$.fragment,o),w($e.$$.fragment,o),w(ke.$$.fragment,o),w(He.$$.fragment,o),w(Pe.$$.fragment,o),w(Te.$$.fragment,o),w(je.$$.fragment,o),w(De.$$.fragment,o),w(Ne.$$.fragment,o),w(de.$$.fragment,o),w(Ae.$$.fragment,o),w(Ie.$$.fragment,o),w(he.$$.fragment,o),w(ze.$$.fragment,o),w(ge.$$.fragment,o),w(Se.$$.fragment,o),w(Ce.$$.fragment,o),w(Ue.$$.fragment,o),w(qe.$$.fragment,o),w(Ke.$$.fragment,o),w(me.$$.fragment,o),st=!1},d(o){t(g),o&&t(k),o&&t(u),x(p),o&&t(E),o&&t(P),x(R),o&&t(Bo),o&&t(B),o&&t(Go),o&&t(X),x(xe),o&&t(Yo),o&&t(H),x($e),x(ke),x(He),x(Pe),x(Te),x(je),o&&t(Jo),o&&t(Z),x(De),o&&t(Qo),o&&t(S),x(Ne),x(de),o&&t(Xo),o&&t(ee),x(Ae),o&&t(Zo),o&&t(C),x(Ie),x(he),o&&t(et),o&&t(U),x(ze),x(ge),o&&t(ot),o&&t(q),x(Se),o&&t(tt),o&&t(oe),x(Ce),o&&t(at),o&&t(te),x(Ue),o&&t(nt),o&&t(ae),x(qe),o&&t(rt),o&&t(N),x(Ke),x(me)}}}const zr={local:"mixins-serialization-methods",sections:[{local:"mixins",sections:[{local:"huggingface_hub.ModelHubMixin",title:"Generic"},{local:"huggingface_hub.PyTorchModelHubMixin",title:"PyTorch"},{local:"huggingface_hub.KerasModelHubMixin",title:"Keras"},{local:"huggingface_hub.from_pretrained_fastai",title:"Fastai"}],title:"Mixins"}],title:"Mixins & serialization methods"};function Or(V){return jr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Wr extends Hr{constructor(g){super();Er(this,g,Or,Lr,Pr,{})}}export{Wr as default,zr as metadata};
